--[[

for index, force in pairs(game.forces) do
	force.reset_recipes()
	force.reset_technologies()
end


]]--


--[[ Tweak Research ]]--

if bobmods.config.tweaks.TweakResearch == true then

	data:extend(
	{
		{
			type = "technology",
			name = "research",
			icon = "__bobtweaks__/graphics/chemistry.png",
			prerequisites =
			{
				"battery",
				"steel-processing",
				"advanced-electronics",
				"basic-research"
			},
			effects =
			{
				{
					type = "unlock-recipe",
					recipe = "science-pack-3"
				}
			},
			unit =
			{
				count = 100,
				ingredients =
				{
					{ "science-pack-1", 1 },
					{ "science-pack-2", 1 },
				},
				time = 30
			},
			order = "c-k-m-1"
		},
		{
			type = "technology",
			name = "basic-research",
			icon = "__bobtweaks__/graphics/basic-research.png",
			prerequisites =
			{
			},
			effects =
			{
				{
					type = "unlock-recipe",
					recipe = "science-pack-2"
				}
			},
			unit =
			{
				count = 50,
				ingredients =
				{
					{ "science-pack-1", 1 }
				},
				time = 15
			},
			order = "c-k-m-0"
		},
		{
			type = "technology",
			name = "alien-technology",
			icon = "__base__/graphics/technology/alien-technology.png",
			effects =
			{
				{
					type = "unlock-recipe",
					recipe = "alien-science-pack"
				}
			},
			prerequisites = { "rocketry" },
			unit =
			{
				count = 300,
				ingredients =
				{
					{ "science-pack-1", 1 },
					{ "science-pack-2", 1 },
					{ "science-pack-3", 1 },
				},
				time = 30
			},
			order = "e-f"
		}
	}
	)

	if data.raw.technology["advanced-research"] then
		bobmods.lib.tech.add_prerequisite("alien-technology", "advanced-research")
	end

	if data.raw.item["science-pack-4"] then
		bobmods.lib.tech.add_new_science_pack("alien-technology", "science-pack-4", 1)
	end

	data.raw.recipe["science-pack-2"].enabled = false

	bobmods.lib.tech.add_prerequisite("barrels", "basic-research")
	bobmods.lib.tech.add_prerequisite("fluid-handling", "electric-engine")

	bobmods.lib.tech.add_prerequisite("automation-4", "research")

	bobmods.lib.tech.add_prerequisite("circuit-network", "basic-research")
	bobmods.lib.tech.add_prerequisite("alloy-processing-2", "research")
	bobmods.lib.tech.add_prerequisite("advanced-electronics-2", "research")
	bobmods.lib.tech.add_prerequisite("advanced-electronics-3", "advanced-research")

	bobmods.lib.tech.replace_prerequisite("laser", "advanced-electronics", "basic-research")
	bobmods.lib.tech.remove_prerequisite("robotics", "advanced-electronics")

	bobmods.lib.tech.replace_prerequisite("electric-engine", "advanced-electronics", "electronics")

	bobmods.lib.tech.add_prerequisite("inserter-stack-size-bonus-1", "basic-research")
	bobmods.lib.tech.add_prerequisite("inserter-stack-size-bonus-3", "research")
	bobmods.lib.tech.add_prerequisite("inserter-stack-size-bonus-4", "alien-technology")

	bobmods.lib.tech.add_prerequisite("long-inserters-2", "basic-research")
	bobmods.lib.tech.add_prerequisite("near-inserters", "basic-research")
	bobmods.lib.tech.add_prerequisite("more-inserters-1", "basic-research")
	bobmods.lib.tech.add_prerequisite("logistics-2", "basic-research")
	bobmods.lib.tech.add_prerequisite("logistics-3", "research")
	bobmods.lib.tech.add_prerequisite("engine", "basic-research")
	bobmods.lib.tech.add_prerequisite("bob-logistics-5", "alien-technology")
	bobmods.lib.tech.add_prerequisite("bob-logistics-5", "advanced-electronics-2")

	bobmods.lib.tech.add_prerequisite("logistic-system", "research")
	bobmods.lib.tech.add_prerequisite("worker-robots-speed-1", "research")
	bobmods.lib.tech.add_prerequisite("worker-robots-storage-1", "research")
	bobmods.lib.tech.add_prerequisite("character-logistic-slots-3", "research")
	bobmods.lib.tech.add_prerequisite("character-logistic-slots-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("character-logistic-slots-7", "alien-technology")
	bobmods.lib.tech.add_prerequisite("character-logistic-slots-8", "alien-research")
	bobmods.lib.tech.add_prerequisite("character-logistic-trash-slots-2", "research")
	bobmods.lib.tech.add_prerequisite("worker-robots-speed-3", "alien-technology")
	bobmods.lib.tech.add_prerequisite("worker-robots-storage-2", "alien-technology")

	bobmods.lib.tech.add_prerequisite("modules", "aluminium-processing")
	bobmods.lib.tech.add_prerequisite("modules", "gold-processing")
	bobmods.lib.tech.add_prerequisite("speed-module-5", "gem-processing-2")
	bobmods.lib.tech.add_prerequisite("effectivity-module-5", "gem-processing-2")
	bobmods.lib.tech.add_prerequisite("productivity-module-5", "gem-processing-2")
	bobmods.lib.tech.add_prerequisite("pollution-clean-module-5", "gem-processing-2")
	bobmods.lib.tech.add_prerequisite("pollution-create-module-5", "gem-processing-2")

	bobmods.lib.tech.add_prerequisite("effect-transmission-3", "alien-technology")

	bobmods.lib.tech.add_prerequisite("character-inventory-slots-1", "basic-research")
	bobmods.lib.tech.add_prerequisite("character-inventory-slots-2", "research")
	bobmods.lib.tech.add_prerequisite("character-inventory-slots-3", "advanced-research")
	bobmods.lib.tech.add_prerequisite("landfill", "basic-research")
	bobmods.lib.tech.add_prerequisite("invar-processing", "basic-research")
	bobmods.lib.tech.add_prerequisite("oil-processing", "basic-research")
	bobmods.lib.tech.add_prerequisite("advanced-material-processing", "basic-research")
	bobmods.lib.tech.add_prerequisite("cobalt-processing", "sulfur-processing")
	bobmods.lib.tech.remove_prerequisite("cobalt-processing", "chemical-processing-1")

	bobmods.lib.tech.add_prerequisite("gas-canisters", "basic-research")
	bobmods.lib.tech.add_prerequisite("lithium-processing", "basic-research")
	bobmods.lib.tech.remove_prerequisite("lithium-processing", "chemical-processing-1")

	bobmods.lib.tech.add_prerequisite("electronics", "chemical-processing-1")
	bobmods.lib.tech.add_prerequisite("electronics", "alloy-processing-1")
	bobmods.lib.tech.add_prerequisite("water-bore-1", "electronics")
	bobmods.lib.tech.add_prerequisite("optics", "electronics")
	bobmods.lib.tech.add_prerequisite("logistics", "electronics")
	bobmods.lib.tech.add_prerequisite("air-compressor-1", "electronics")
	bobmods.lib.tech.add_prerequisite("titanium-processing", "research")
	bobmods.lib.tech.add_prerequisite("tungsten-processing", "research")
	bobmods.lib.tech.add_prerequisite("toolbelt", "basic-research")
	bobmods.lib.tech.add_prerequisite("toolbelt-2", "research")
	bobmods.lib.tech.add_prerequisite("toolbelt-3", "advanced-research")
	bobmods.lib.tech.add_prerequisite("research-speed-1", "basic-research")
	bobmods.lib.tech.add_prerequisite("research-speed-3", "research")
	bobmods.lib.tech.add_prerequisite("advanced-oil-processing", "research")
	bobmods.lib.tech.add_prerequisite("ceramics", "research")
	bobmods.lib.tech.remove_prerequisite("ceramics", "silicon-processing")

	bobmods.lib.tech.add_prerequisite("nitroglycerin-processing", "research")
	bobmods.lib.tech.add_prerequisite("electrum-processing", "research")
	bobmods.lib.tech.add_prerequisite("nitinol-processing", "advanced-research")

	if data.raw.technology["advanced-electronics-3"] then
		data.raw.technology["advanced-electronics-3"].icon = "__base__/graphics/technology/advanced-electronics-2.png"
	end

	bobmods.lib.tech.add_prerequisite("gem-processing-2", "research")

	bobmods.lib.tech.add_prerequisite("electrolysis-2", "basic-research")
	bobmods.lib.tech.remove_prerequisite("electrolyser-2", "steel-processing")
	bobmods.lib.tech.remove_prerequisite("electrolyser-3", "plastics")

	bobmods.lib.tech.add_prerequisite("chemical-plant", "basic-research")

	bobmods.lib.tech.add_prerequisite("chemical-processing-2", "oil-processing")
	bobmods.lib.tech.add_prerequisite("chemical-processing-3", "research")
	bobmods.lib.tech.add_prerequisite("tungsten-alloy-processing", "advanced-research")

	bobmods.lib.tech.add_prerequisite("battery", "lead-processing")
	bobmods.lib.tech.remove_recipe_unlock("battery", "science-pack-3")

	bobmods.lib.tech.add_prerequisite("battery-2", "research")
	bobmods.lib.tech.add_prerequisite("battery-3", "advanced-research")
	bobmods.lib.tech.remove_prerequisite("bob-boiler-3", "advanced-electronics")

	bobmods.lib.tech.add_prerequisite("electric-energy-distribution-1", "basic-research")
	bobmods.lib.tech.add_prerequisite("electric-energy-distribution-2", "advanced-electronics")
	bobmods.lib.tech.add_prerequisite("electric-energy-distribution-2", "research")
	bobmods.lib.tech.add_prerequisite("solar-energy", "basic-research")
	bobmods.lib.tech.add_prerequisite("bob-solar-energy-3", "research")

	bobmods.lib.tech.add_prerequisite("electric-pole-3", "research")
	bobmods.lib.tech.remove_prerequisite("bob-solar-energy-4", "silicon-processing")
	bobmods.lib.tech.remove_prerequisite("bob-solar-energy-4", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("bob-solar-energy-4", "advanced-research")

	bobmods.lib.tech.replace_prerequisite("advanced-research", "advanced-electronics", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("advanced-research", "ceramics")
	bobmods.lib.tech.add_prerequisite("advanced-research", "battery-2")

	bobmods.lib.tech.add_prerequisite("gates", "electronics")

	bobmods.lib.tech.add_prerequisite("combat-robotics", "electronics")
	bobmods.lib.tech.add_prerequisite("combat-robotics-2", "advanced-electronics")
	bobmods.lib.tech.add_prerequisite("combat-robotics-3", "alien-technology")

	bobmods.lib.tech.add_prerequisite("rocketry", "tungsten-processing")
	bobmods.lib.tech.add_prerequisite("tanks", "advanced-electronics")
	bobmods.lib.tech.add_prerequisite("tanks", "plastics")
	bobmods.lib.tech.add_prerequisite("tanks", "explosives")
	bobmods.lib.tech.add_prerequisite("bob-robot-tanks", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("bob-rocket", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("bob-piercing-rocket", "advanced-electronics-2")
	-- table.insert(data.raw.technology["bob-impact-rocket", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("bob-explosive-rocket", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("bob-acid-rocket", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("bob-flame-rocket", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("bob-poison-rocket", "advanced-electronics-2")

	bobmods.lib.tech.add_prerequisite("armor-making-3", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("bob-power-armor-3", "alien-research")
	bobmods.lib.tech.add_prerequisite("bob-turrets-2", "basic-research")

	bobmods.lib.tech.add_prerequisite("bullet-damage-2", "basic-research")
	bobmods.lib.tech.add_prerequisite("bullet-damage-4", "research")
	bobmods.lib.tech.add_prerequisite("bullet-damage-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("bullet-damage-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("bullet-speed-3", "basic-research")
	bobmods.lib.tech.add_prerequisite("bullet-speed-4", "research")
	bobmods.lib.tech.add_prerequisite("bullet-speed-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("bullet-speed-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("shotgun-shell-damage-2", "basic-research")
	bobmods.lib.tech.add_prerequisite("shotgun-shell-damage-4", "research")
	bobmods.lib.tech.add_prerequisite("shotgun-shell-damage-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("shotgun-shell-damage-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("shotgun-shell-speed-3", "basic-research")
	bobmods.lib.tech.add_prerequisite("shotgun-shell-speed-4", "research")
	bobmods.lib.tech.add_prerequisite("shotgun-shell-speed-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("shotgun-shell-speed-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("bob-sniper-turret-damage-4", "research")
	bobmods.lib.tech.add_prerequisite("bob-sniper-turret-damage-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("bob-sniper-turret-damage-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("gun-turret-damage-1", "basic-research")
	bobmods.lib.tech.add_prerequisite("gun-turret-damage-4", "research")
	bobmods.lib.tech.add_prerequisite("gun-turret-damage-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("gun-turret-damage-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("laser-turret-damage-4", "research")
	bobmods.lib.tech.add_prerequisite("laser-turret-damage-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("laser-turret-damage-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("laser-turret-speed-4", "research")
	bobmods.lib.tech.add_prerequisite("laser-turret-speed-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("laser-turret-speed-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("follower-robot-count-3", "research")
	bobmods.lib.tech.add_prerequisite("follower-robot-count-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("combat-robot-damage-3", "research")
	bobmods.lib.tech.add_prerequisite("combat-robot-damage-4", "alien-technology")
	bobmods.lib.tech.add_prerequisite("bob-sniper-turrets-1", "basic-research")
	bobmods.lib.tech.add_prerequisite("bob-sniper-turrets-2", "research")
	bobmods.lib.tech.add_prerequisite("bob-sniper-turrets-3", "titanium-processing")
	bobmods.lib.tech.add_prerequisite("bob-laser-rifle", "advanced-electronics")
	bobmods.lib.tech.add_prerequisite("bob-laser-rifle-damage-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("bob-laser-rifle-damage-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("bob-laser-rifle-speed-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("bob-laser-rifle-speed-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("bob-tank-cannon-damage-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("bob-tank-cannon-damage-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("bob-tank-cannon-speed-5", "advanced-research")
	bobmods.lib.tech.add_prerequisite("bob-tank-cannon-speed-6", "alien-technology")
	bobmods.lib.tech.add_prerequisite("bob-laser-rifle-ammo-4", "advanced-research")
	bobmods.lib.tech.add_prerequisite("bob-laser-rifle-ammo-6", "alien-technology")

	bobmods.lib.tech.add_prerequisite("military-2", "basic-research")
	bobmods.lib.tech.add_prerequisite("military-3", "aluminium-processing")
	bobmods.lib.tech.add_prerequisite("military-3", "research")
	bobmods.lib.tech.remove_prerequisite("military-3", "rocketry")
	bobmods.lib.tech.add_prerequisite("military-4", "alien-technology")

	bobmods.lib.tech.remove_prerequisite("solar-panel-equipment-3", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("solar-panel-equipment-4", "alien-technology")

	bobmods.lib.tech.remove_prerequisite("night-vision-equipment-2", "advanced-electronics-2")
	bobmods.lib.tech.add_prerequisite("night-vision-equipment-3", "alien-technology")

	bobmods.lib.tech.add_prerequisite("exoskeleton-equipment-3", "alien-technology")
	bobmods.lib.tech.add_prerequisite("personal-laser-defense-equipment-6", "alien-technology")

	bobmods.lib.tech.add_prerequisite("fusion-reactor-equipment-2", "alien-research")

	bobmods.lib.tech.add_prerequisite("battery-equipment-4", "alien-research")

	bobmods.lib.tech.add_prerequisite("energy-shield-equipment-3", "alien-technology")
	bobmods.lib.tech.add_prerequisite("energy-shield-equipment-4", "alien-research")

end

--[[ Tweak Order ]]--

if bobmods.config.tweaks.TweakOrder == true then

	data:extend(
	{
		{
			type = "item-subgroup",
			name = "alien-science-pack",
			group = "intermediate-products",
			order = "i",
		},
		{
			type = "item-subgroup",
			name = "small-alien-artifacts",
			group = "intermediate-products",
			order = "f",
		},
		{
			type = "item-subgroup",
			name = "alien-artifacts",
			group = "intermediate-products",
			order = "g",
		},
		{
			type = "item-subgroup",
			name = "belt",
			group = "logistics",
			order = "b",
		},
		{
			type = "item-subgroup",
			name = "belt-to-ground",
			group = "logistics",
			order = "c",
		},
		{
			type = "item-subgroup",
			name = "belt-splitter",
			group = "logistics",
			order = "d",
		},
		{
			type = "item-subgroup",
			name = "train-system",
			group = "logistics",
			order = "g",
		},
		{
			type = "item-subgroup",
			name = "rail-stock",
			group = "logistics",
			order = "h",
		},
		{
			type = "item-subgroup",
			name = "energy-substations",
			group = "logistics",
			order = "f",
		}
	}
	)

	if data.raw["item-group"]["bob-logistics"] then
		data:extend(
		{
			{
				type = "item-subgroup",
				name = "inserter",
				group = "bob-logistics",
				order = "h",
			},
			{
				type = "item-subgroup",
				name = "pumps",
				group = "bob-logistics",
				order = "d-b",
			}
		} )
	end

	bobmods.lib.item.replace_subgroup("copper-cable", "bob-electronic-components")
	bobmods.lib.item.replace_order("copper-cable", "0-a0[copper-cable]")

	data.raw["item-subgroup"]["science-pack"].order = "h"

	bobmods.lib.item.replace_subgroup("alien-artifact", "alien-artifacts")
	bobmods.lib.item.replace_order("alien-artifact", "a")
	bobmods.lib.item.replace_subgroup("alien-artifact-red", "alien-artifacts")
	bobmods.lib.item.replace_order("alien-artifact-red", "b")
	bobmods.lib.item.replace_subgroup("alien-artifact-orange", "alien-artifacts")
	bobmods.lib.item.replace_order("alien-artifact-orange", "c")
	bobmods.lib.item.replace_subgroup("alien-artifact-yellow", "alien-artifacts")
	bobmods.lib.item.replace_order("alien-artifact-yellow", "d")
	bobmods.lib.item.replace_subgroup("alien-artifact-green", "alien-artifacts")
	bobmods.lib.item.replace_order("alien-artifact-green", "e")
	bobmods.lib.item.replace_subgroup("alien-artifact-blue", "alien-artifacts")
	bobmods.lib.item.replace_order("alien-artifact-blue", "f")
	bobmods.lib.item.replace_subgroup("alien-artifact-purple", "alien-artifacts")
	bobmods.lib.item.replace_order("alien-artifact-purple", "g")

	bobmods.lib.item.replace_subgroup("small-alien-artifact", "small-alien-artifacts")
	bobmods.lib.item.replace_order("small-alien-artifact", "a")
	bobmods.lib.item.replace_subgroup("small-alien-artifact-red", "small-alien-artifacts")
	bobmods.lib.item.replace_order("small-alien-artifact-red", "b")
	bobmods.lib.item.replace_subgroup("small-alien-artifact-orange", "small-alien-artifacts")
	bobmods.lib.item.replace_order("small-alien-artifact-orange", "c")
	bobmods.lib.item.replace_subgroup("small-alien-artifact-yellow", "small-alien-artifacts")
	bobmods.lib.item.replace_order("small-alien-artifact-yellow", "d")
	bobmods.lib.item.replace_subgroup("small-alien-artifact-green", "small-alien-artifacts")
	bobmods.lib.item.replace_order("small-alien-artifact-green", "e")
	bobmods.lib.item.replace_subgroup("small-alien-artifact-blue", "small-alien-artifacts")
	bobmods.lib.item.replace_order("small-alien-artifact-blue", "f")
	bobmods.lib.item.replace_subgroup("small-alien-artifact-purple", "small-alien-artifacts")
	bobmods.lib.item.replace_order("small-alien-artifact-purple", "g")

	bobmods.lib.item.replace_subgroup("logistic-chest-active-provider", "storage")
	bobmods.lib.item.replace_subgroup("logistic-chest-passive-provider", "storage")
	bobmods.lib.item.replace_subgroup("logistic-chest-requester", "storage")
	bobmods.lib.item.replace_subgroup("logistic-chest-storage", "storage")

	bobmods.lib.item.replace_order("logistic-chest-active-provider", "a[items]-e[active-provider]")
	bobmods.lib.item.replace_order("logistic-chest-passive-provider", "a[items]-f[passive-provider]")
	bobmods.lib.item.replace_order("logistic-chest-requester", "a[items]-g[requester]")
	bobmods.lib.item.replace_order("logistic-chest-storage", "a[items]-h[storage]")

	bobmods.lib.item.replace_subgroup("storage-tank", "bob-storage")

	bobmods.lib.item.replace_subgroup("green-transport-belt", "belt")
	bobmods.lib.item.replace_subgroup("purple-transport-belt", "belt")

	bobmods.lib.item.replace_subgroup("underground-belt", "belt-to-ground")
	bobmods.lib.item.replace_subgroup("fast-underground-belt", "belt-to-ground")
	bobmods.lib.item.replace_subgroup("express-underground-belt", "belt-to-ground")
	bobmods.lib.item.replace_subgroup("green-underground-belt", "belt-to-ground")
	bobmods.lib.item.replace_subgroup("purple-underground-belt", "belt-to-ground")

	bobmods.lib.item.replace_subgroup("splitter", "belt-splitter")
	bobmods.lib.item.replace_subgroup("fast-splitter", "belt-splitter")
	bobmods.lib.item.replace_subgroup("express-splitter", "belt-splitter")
	bobmods.lib.item.replace_subgroup("green-splitter", "belt-splitter")
	bobmods.lib.item.replace_subgroup("purple-splitter", "belt-splitter")

	bobmods.lib.item.replace_subgroup("small-pump", "pumps")
	bobmods.lib.item.replace_order("small-pump", "a")
	bobmods.lib.item.replace_subgroup("small-pump-2", "pumps")
	bobmods.lib.item.replace_order("small-pump-2", "b")
	bobmods.lib.item.replace_subgroup("small-pump-3", "pumps")
	bobmods.lib.item.replace_order("small-pump-3", "c")
	bobmods.lib.item.replace_subgroup("small-pump-4", "pumps")
	bobmods.lib.item.replace_order("small-pump-4", "d")
	bobmods.lib.item.replace_subgroup("valve", "pumps")
	bobmods.lib.item.replace_order("valve", "z")

	bobmods.lib.item.replace_subgroup_group("inserter", "bob-logistics")
	bobmods.lib.item.replace_subgroup_order("inserter", "b")
	bobmods.lib.item.replace_subgroup_group("bob-smart-inserter", "bob-logistics")
	bobmods.lib.item.replace_subgroup_order("bob-smart-inserter", "d")

	bobmods.lib.item.replace_subgroup_order("energy-pipe-distribution", "e")

	data.raw["rail-planner"]["rail"].subgroup = "train-system"
	bobmods.lib.item.replace_subgroup("train-stop", "train-system")
	bobmods.lib.item.replace_subgroup("rail-signal", "train-system")
	bobmods.lib.item.replace_subgroup("rail-chain-signal", "train-system")
	bobmods.lib.item.replace_subgroup("diesel-locomotive", "rail-stock")
	bobmods.lib.item.replace_order("diesel-locomotive", "a[rail-stock]-a[diesel-locomotive]")
	bobmods.lib.item.replace_subgroup("diesel-locomotive-2", "rail-stock")
	bobmods.lib.item.replace_order("diesel-locomotive-2", "a[rail-stock]-b[diesel-locomotive-2]")
	bobmods.lib.item.replace_subgroup("diesel-locomotive-3", "rail-stock")
	bobmods.lib.item.replace_order("diesel-locomotive-3", "a[rail-stock]-c[diesel-locomotive-3]")
	bobmods.lib.item.replace_subgroup("armoured-diesel-locomotive", "rail-stock")
	bobmods.lib.item.replace_order("armoured-diesel-locomotive", "a[rail-stock]-d[armoured-diesel-locomotive]")

	bobmods.lib.item.replace_subgroup("cargo-wagon", "rail-stock")
	bobmods.lib.item.replace_order("cargo-wagon", "a[rail-stock]-e[cargo-wagon]")
	bobmods.lib.item.replace_subgroup("cargo-wagon-2", "rail-stock")
	bobmods.lib.item.replace_order("cargo-wagon-2", "a[rail-stock]-f[cargo-wagon-2]")
	bobmods.lib.item.replace_subgroup("cargo-wagon-3", "rail-stock")
	bobmods.lib.item.replace_order("cargo-wagon-3", "a[rail-stock]-g[cargo-wagon-3]")
	bobmods.lib.item.replace_subgroup("armoured-cargo-wagon", "rail-stock")
	bobmods.lib.item.replace_order("armoured-cargo-wagon", "a[rail-stock]-h[armoured-cargo-wagon]")

	bobmods.lib.item.replace_subgroup_order("transport", "i")
	bobmods.lib.item.replace_subgroup_order("logistic-network", "j")
	bobmods.lib.item.replace_subgroup_order("circuit-network", "k")
	bobmods.lib.item.replace_subgroup_order("terrain", "l")

	bobmods.lib.item.replace_subgroup("logistic-robot", "bob-logistic-robots")
	bobmods.lib.item.replace_subgroup("construction-robot", "bob-logistic-robots")
	bobmods.lib.item.replace_subgroup("bob-roboport-2", "logistic-network")
	bobmods.lib.item.replace_subgroup("bob-roboport-3", "logistic-network")
	bobmods.lib.item.replace_subgroup("bob-roboport-4", "logistic-network")

	bobmods.lib.item.replace_subgroup("flying-robot-frame", "bob-intermediates")

	if data.raw["roboport"]["roboport"] then
		data.raw["roboport"]["roboport"].radius_visualisation_picture = { filename = "__bobtweaks__/graphics/roboport-radius-visualization.png", width = 12, height = 12 }
	end

	if data.raw["roboport"]["bob-roboport-2"] then
		data.raw["roboport"]["bob-roboport-2"].radius_visualisation_picture = { filename = "__bobtweaks__/graphics/roboport-radius-visualization.png", width = 12, height = 12 }
	end

	if data.raw["roboport"]["bob-roboport-3"] then
		data.raw["roboport"]["bob-roboport-3"].radius_visualisation_picture = { filename = "__bobtweaks__/graphics/roboport-radius-visualization.png", width = 12, height = 12 }
	end

	if data.raw["roboport"]["bob-roboport-4"] then
		data.raw["roboport"]["bob-roboport-4"].radius_visualisation_picture = { filename = "__bobtweaks__/graphics/roboport-radius-visualization.png", width = 12, height = 12 }
	end

	data.raw["repair-tool"]["repair-pack"].subgroup = "energy"
	data.raw["blueprint"]["blueprint"].subgroup = "energy"
	data.raw["deconstruction-item"]["deconstruction-planner"].subgroup = "energy"

	bobmods.lib.item.replace_subgroup("stone", "bob-ores")
	bobmods.lib.item.replace_subgroup("iron-ore", "bob-ores")
	bobmods.lib.item.replace_subgroup("copper-ore", "bob-ores")
	bobmods.lib.item.replace_subgroup("coal", "bob-ores")
	bobmods.lib.item.replace_subgroup("raw-wood", "bob-ores")

	bobmods.lib.item.replace_order("stone", "f-a[stone]")
	bobmods.lib.item.replace_order("iron-ore", "f-a[iron-ore]")
	bobmods.lib.item.replace_order("copper-ore", "f-a[copper-ore]")
	bobmods.lib.item.replace_order("coal", "f-a[coal]")
	bobmods.lib.item.replace_order("raw-wood", "f-z[coal]")

	bobmods.lib.item.replace_subgroup_group("barrel", "bob-fluid-products")
	bobmods.lib.item.replace_subgroup_order("barrel", "a-d")
	bobmods.lib.item.replace_subgroup_order("bob-gas-bottle", "a-d")
	bobmods.lib.item.replace_subgroup_order("bob-empty-gas-bottle", "a-d2")
	bobmods.lib.item.replace_subgroup_order("bob-barrel", "a-f")
	bobmods.lib.item.replace_subgroup_order("bob-empty-barrel", "a-f2")
	bobmods.lib.item.replace_subgroup_order("bob-canister", "a-g")
	bobmods.lib.item.replace_subgroup_order("bob-empty-canister", "a-g2")

	bobmods.lib.recipe.replace_subgroup("empty-barrel", "barrel")
	bobmods.lib.recipe.replace_subgroup("gas-canister", "barrel")
	bobmods.lib.recipe.replace_subgroup("empty-canister", "barrel")

	bobmods.lib.item.replace_subgroup("lithium-ion-battery", "intermediate-product")
	bobmods.lib.item.replace_order("lithium-ion-battery", "i[lithium-ion-battery]")

	bobmods.lib.item.replace_subgroup("silver-zinc-battery", "intermediate-product")
	bobmods.lib.item.replace_order("silver-zinc-battery", "i[silver-zinc-battery]")

	bobmods.lib.item.replace_subgroup("iron-gear-wheel", "bob-gears")
	bobmods.lib.item.replace_order("iron-gear-wheel", "a[iron-gear-wheel]")

	bobmods.lib.item.replace_subgroup("iron-plate", "bob-material")
	bobmods.lib.item.replace_order("iron-plate", "c-a-0[iron-plate]")
	bobmods.lib.item.replace_subgroup("copper-plate", "bob-material")
	bobmods.lib.item.replace_order("copper-plate", "c-a-0[copper-plate]")
	bobmods.lib.item.replace_subgroup("steel-plate", "bob-alloy")
	bobmods.lib.item.replace_order("steel-plate", "c-b-0[steel-plate]")

	bobmods.lib.recipe.replace_subgroup("iron-plate", "bob-material")
	bobmods.lib.recipe.replace_order("iron-plate", "c-a-0[iron-plate]")
	bobmods.lib.recipe.replace_subgroup("copper-plate", "bob-material")
	bobmods.lib.recipe.replace_order("copper-plate", "c-a-0[copper-plate]")
	bobmods.lib.recipe.replace_subgroup("steel-plate", "bob-alloy")
	bobmods.lib.recipe.replace_order("steel-plate", "c-b-0[steel-plate]")

	bobmods.lib.recipe.replace_subgroup("wood", "bob-resource")
	bobmods.lib.recipe.replace_order("wood", "0[wood]")
	bobmods.lib.item.replace_subgroup("wood", "bob-resource")
	bobmods.lib.recipe.replace_subgroup("plastic-bar", "bob-resource")
	bobmods.lib.item.replace_subgroup("plastic-bar", "bob-resource")
	bobmods.lib.recipe.replace_subgroup("sulfur", "bob-resource-chemical")
	bobmods.lib.item.replace_subgroup("sulfur", "bob-resource-chemical")

	bobmods.lib.item.replace_subgroup("substation", "energy-substations")
	bobmods.lib.item.replace_subgroup("substation-2", "energy-substations")
	bobmods.lib.item.replace_subgroup("substation-3", "energy-substations")
	bobmods.lib.item.replace_subgroup("substation-4", "energy-substations")

	bobmods.lib.item.replace_order("solar-panel-small", "a")
	bobmods.lib.item.replace_order("solar-panel-small-2", "b")
	bobmods.lib.item.replace_order("solar-panel-small-3", "c")
	bobmods.lib.item.replace_order("solar-panel", "d")
	bobmods.lib.item.replace_order("solar-panel-2", "e")
	bobmods.lib.item.replace_order("solar-panel-3", "f")
	bobmods.lib.item.replace_order("solar-panel-large", "g")
	bobmods.lib.item.replace_order("solar-panel-large-2", "h")
	bobmods.lib.item.replace_order("solar-panel-large-3", "i")

	bobmods.lib.item.replace_order("accumulator", "a")
	bobmods.lib.item.replace_order("fast-accumulator", "b")
	bobmods.lib.item.replace_order("fast-accumulator-2", "c")
	bobmods.lib.item.replace_order("fast-accumulator-3", "d")
	bobmods.lib.item.replace_order("large-accumulator", "e")
	bobmods.lib.item.replace_order("large-accumulator-2", "f")
	bobmods.lib.item.replace_order("large-accumulator-3", "g")
	bobmods.lib.item.replace_order("slow-accumulator", "h")
	bobmods.lib.item.replace_order("slow-accumulator-2", "i")
	bobmods.lib.item.replace_order("slow-accumulator-3", "j")

	bobmods.lib.tool.replace_subgroup("alien-science-pack", "alien-science-pack")
	bobmods.lib.tool.replace_order("alien-science-pack", "a")
	bobmods.lib.tool.replace_subgroup("alien-science-pack-red", "alien-science-pack")
	bobmods.lib.tool.replace_order("alien-science-pack-red", "b")
	bobmods.lib.tool.replace_subgroup("alien-science-pack-orange", "alien-science-pack")
	bobmods.lib.tool.replace_order("alien-science-pack-orange", "c")
	bobmods.lib.tool.replace_subgroup("alien-science-pack-yellow", "alien-science-pack")
	bobmods.lib.tool.replace_order("alien-science-pack-yellow", "d")
	bobmods.lib.tool.replace_subgroup("alien-science-pack-green", "alien-science-pack")
	bobmods.lib.tool.replace_order("alien-science-pack-green", "e")
	bobmods.lib.tool.replace_subgroup("alien-science-pack-blue", "alien-science-pack")
	bobmods.lib.tool.replace_order("alien-science-pack-blue", "f")
	bobmods.lib.tool.replace_subgroup("alien-science-pack-purple", "alien-science-pack")
	bobmods.lib.tool.replace_order("alien-science-pack-purple", "g")

	bobmods.lib.item.replace_order("stone-wall", "a[stone-wall]-a[stone-wall]")
	bobmods.lib.item.replace_order("gate", "a[stone-wall]-b[gate]")
	bobmods.lib.item.replace_order("reinforced-wall", "a[stone-wall]-c[reinforced]")
	bobmods.lib.item.replace_order("reinforced-gate", "a[stone-wall]-d[reinforced]")

end


--[[ Tweak Recipies ]]--

if bobmods.config.tweaks.TweakRecipies == true then

	bobmods.lib.tech.remove_recipe_unlock("automation", "long-handed-inserter")
	bobmods.lib.tech.add_recipe_unlock("long-inserters-1", "long-handed-inserter")

	bobmods.lib.tech.remove_recipe_unlock("electronics", "filter-inserter")
	bobmods.lib.tech.add_recipe_unlock("logistics", "filter-inserter")

	bobmods.lib.recipe.replace_category("green-transport-belt", "crafting-with-fluid")
	bobmods.lib.recipe.replace_category("purple-transport-belt", "crafting-with-fluid")
	bobmods.lib.recipe.replace_category("green-underground-belt", "crafting-with-fluid")
	bobmods.lib.recipe.replace_category("purple-underground-belt", "crafting-with-fluid")
	bobmods.lib.recipe.replace_category("green-splitter", "crafting-with-fluid")
	bobmods.lib.recipe.replace_category("purple-splitter", "crafting-with-fluid")

	bobmods.lib.recipe.replace_ingredient("express-transport-belt", "iron-gear-wheel", "steel-gear-wheel")
	bobmods.lib.recipe.replace_ingredient("express-underground-belt", "iron-gear-wheel", "steel-gear-wheel")
	bobmods.lib.recipe.replace_ingredient("express-splitter", "iron-gear-wheel", "steel-gear-wheel")

	bobmods.lib.recipe.add_new_ingredient("green-transport-belt", { type = "fluid", name = "lubricant", amount = 3 })
	bobmods.lib.recipe.add_new_ingredient("green-underground-belt", { type = "fluid", name = "lubricant", amount = 15 })
	bobmods.lib.recipe.add_new_ingredient("green-splitter", { type = "fluid", name = "lubricant", amount = 10 })

	bobmods.lib.recipe.add_new_ingredient("purple-transport-belt", { type = "fluid", name = "lubricant", amount = 4 })
	bobmods.lib.recipe.add_new_ingredient("purple-underground-belt", { type = "fluid", name = "lubricant", amount = 20 })
	bobmods.lib.recipe.add_new_ingredient("purple-splitter", { type = "fluid", name = "lubricant", amount = 15 })

	bobmods.lib.recipe.add_new_ingredient("speed-module-3", { "module-contact", 5 })
	bobmods.lib.recipe.add_new_ingredient("effectivity-module-3", { "module-contact", 5 })
	bobmods.lib.recipe.add_new_ingredient("productivity-module-3", { "module-contact", 5 })
	bobmods.lib.recipe.add_new_ingredient("pollution-clean-module-3", { "module-contact", 5 })
	bobmods.lib.recipe.add_new_ingredient("pollution-create-module-3", { "module-contact", 5 })

end


--[[ Marathon Research ]]--

if bobmods.config.tweaks.MarathonResearch == true then

	for i, tech in pairs(data.raw.technology) do
		tech.unit.count = tech.unit.count * bobmods.config.tweaks.MarathonResearchMultiplier
	end

end


--[[ Marathon Recipies ]]--

if bobmods.config.tweaks.MarathonRecipies == true then

	bobmods.lib.recipe.replace_ingredient_amount("copper-plate", "copper-ore", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("iron-plate", "iron-ore", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("lead-plate", "lead-ore", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("silver-plate", "silver-ore", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("tin-plate", "tin-ore", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("bob-gold-plate", "gold-ore", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("cobalt-plate", "cobalt-oxide", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("bob-zinc-plate", "zinc-ore", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("bob-nickel-plate", "nickel-ore", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("bob-aluminium-plate", "alumina", 2 * bobmods.config.tweaks.MarathonRecipiesMultiplier)

	bobmods.lib.recipe.replace_ingredient_amount("copper-cable", "copper-plate", bobmods.config.tweaks.MarathonRecipiesMultiplier)

	bobmods.lib.recipe.replace_ingredient_amount("steel-plate", "iron-plate", 2 * bobmods.config.tweaks.MarathonRecipiesMultiplier)

	bobmods.lib.recipe.replace_ingredient_amount("burner-inserter", "iron-plate", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("burner-inserter", "iron-gear-wheel", bobmods.config.tweaks.MarathonRecipiesMultiplier)

	bobmods.lib.recipe.replace_ingredient_amount("inserter", "iron-plate", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("inserter", "iron-gear-wheel", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("inserter", "basic-circuit-board", bobmods.config.tweaks.MarathonRecipiesMultiplier)

	bobmods.lib.recipe.replace_ingredient_amount("transport-belt", "iron-plate", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("transport-belt", "iron-gear-wheel", bobmods.config.tweaks.MarathonRecipiesMultiplier)

	bobmods.lib.recipe.replace_ingredient_amount("science-pack-1", "copper-plate", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("science-pack-1", "iron-gear-wheel", bobmods.config.tweaks.MarathonRecipiesMultiplier)

	bobmods.lib.recipe.replace_ingredient_amount("science-pack-2", "inserter", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("science-pack-2", "transport-belt", bobmods.config.tweaks.MarathonRecipiesMultiplier)

	bobmods.lib.recipe.replace_ingredient_amount("science-pack-3", "battery", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("science-pack-3", "steel-plate", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("science-pack-3", "advanced-circuit", bobmods.config.tweaks.MarathonRecipiesMultiplier)
	bobmods.lib.recipe.replace_ingredient_amount("science-pack-3", "filter-inserter", bobmods.config.tweaks.MarathonRecipiesMultiplier)

end


--[[ Marathon Lower Fuel Energy ]]--

if bobmods.config.tweaks.MarathonLowerFuelEnergy == true then

	data.raw.item["raw-wood"].fuel_value = "2MJ"
	data.raw.item["coal"].fuel_value = "4MJ"

	if data.raw.item["coal"] then
		data.raw.item["carbon"].fuel_value = "2MJ"
	end

end


