if not bobmods.lib.tool then bobmods.lib.tool = {} end

function bobmods.lib.item.replace_subgroup(item, subgroup)
	if data.raw.item[item] and data.raw["item-subgroup"][subgroup] then
		data.raw.item[item].subgroup = subgroup
	else
		log("Item " .. item .. " does not exist.")
	end
end

function bobmods.lib.item.replace_order(item, order)
	if data.raw.item[item] then
		data.raw.item[item].order = order
	else
		log("Item " .. item .. " does not exist.")
	end
end

function bobmods.lib.item.replace_subgroup_group(subgroup, group)
	if data.raw["item-subgroup"][subgroup] and data.raw["item-group"][group] then
		data.raw["item-subgroup"][subgroup].group = group
	else
		log("Item " .. subgroup .. " does not exist.")
	end
end

function bobmods.lib.item.replace_subgroup_order(subgroup, order)
	if data.raw["item-subgroup"][subgroup] then
		data.raw["item-subgroup"][subgroup].order = order
	else
		log("Item " .. subgroup .. " does not exist.")
	end
end

function bobmods.lib.recipe.replace_subgroup(item, subgroup)
	if data.raw.recipe[item] and data.raw["item-subgroup"][subgroup] then
		data.raw.recipe[item].subgroup = subgroup
	else
		log("Recipe " .. item .. " does not exist.")
	end
end

function bobmods.lib.recipe.replace_order(recipe, order)
	if data.raw.recipe[recipe] then
		data.raw.recipe[recipe].order = order
	else
		log("Recipe " .. recipe .. " does not exist.")
	end
end

function bobmods.lib.recipe.replace_category(recipe, category)
	if data.raw.recipe[recipe] then
		data.raw.recipe[recipe].category = category
	else
		log("Recipe " .. recipe .. " does not exist.")
	end
end

function bobmods.lib.recipe.replace_ingredient_amount(recipe, ingredient, amount)
	bobmods.lib.recipe.remove_ingredient(recipe, ingredient)
	bobmods.lib.recipe.add_ingredient(recipe, { ingredient, amount })
end

function bobmods.lib.tool.replace_subgroup(item, subgroup)
	if data.raw.tool[item] then
		data.raw.tool[item].subgroup = subgroup
	else
		log("Tool " .. item .. " does not exist.")
	end
end

function bobmods.lib.tool.replace_order(item, order)
	if data.raw.tool[item] then
		data.raw.tool[item].order = order
	else
		log("Tool " .. item .. " does not exist.")
	end
end
